#include "AfterImageP.h"

#include "etc.h"
#include "ColorGC.h"

/*===========================================================================*/
/* Фμ                                                              */
/*===========================================================================*/

int AfterImages_GetNumber(AfterImages after_images)
{
  return (after_images->number);
}

XArc * AfterImages_GetArcs(AfterImages after_images)
{
  return (after_images->arcs);
}

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

AfterImages AfterImages_Create(int size, int number, double * x, double * y,
			       int x_min, int y_min, int x_max, int y_max,
			       ObjList list)
{
  AfterImages after_images;
  int i, n;

  after_images = (AfterImages)malloc(sizeof(_AfterImages));
  if (after_images == NULL)
    Error("AfterImages_Create", "Cannot allocate memory");

  after_images->arcs = (XArc *)malloc(sizeof(XArc) * number);
  if (after_images->arcs == NULL)
    Error("AfterImages_Create", "Cannot allocate memory");

  n = 0;
  for (i = 0; i < number; i++) {

    if ((x[i] < x_min) || (x[i] > x_max) || (y[i] > y_max)) {
      continue;
    }

    after_images->arcs[n].x = x[i] - size / 2;
    after_images->arcs[n].y = y[i] - size / 2;
    after_images->arcs[n].width  = size;
    after_images->arcs[n].height = size;
    after_images->arcs[n].angle1 = 0;
    after_images->arcs[n].angle2 = 360*64;
    n++;
  }
  after_images->number = n;
  after_images->list = list;
  after_images->current = ObjList_GetStart(after_images->list);

  return (after_images);
}

AfterImages AfterImages_Destroy(AfterImages after_images)
{
  if (!after_images) return (NULL);

  if (after_images->arcs) free(after_images->arcs);

  free(after_images);

  return (NULL);
}

/*===========================================================================*/
/* ߤοͤGC֤current ˿ʤ롥(Ǹˤ NULL ֤)  */
/*===========================================================================*/

GC AfterImages_GetGC(AfterImages after_images)
{
  ColorGC color_gc;
  GC gc;

  if (after_images->current == NULL) return (NULL);
  if (ObjList_IsEndEdge(after_images->list, after_images->current))
    return (NULL);

  color_gc = (ColorGC)ObjListData_GetObj(after_images->current);
  gc =  ColorGC_GetGC(color_gc);

  after_images->current = ObjListData_GetNext(after_images->current);

  return (gc);
}

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
