#ifndef _XHANABI_Tama_h_INCLUDED_
#define _XHANABI_Tama_h_INCLUDED_

typedef struct _TamaClass * TamaClass;
typedef struct _TamaNext * TamaNext;
typedef struct _Tamas * Tamas;

#include "Obj.h"
#include "Stream.h"
#include "ColorGC.h"
#include "AfterImage.h"

/*===========================================================================*/
/* ֥ȤΥФμ                                                */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* TamaClass 饹                                                          */
/*---------------------------------------------------------------------------*/

char * TamaClass_GetName(TamaClass tama_class);
double TamaClass_GetProbability(TamaClass tama_class);
ObjList TamaClass_GetGCListList(TamaClass tama_class);
ObjList TamaClass_GetNextList(TamaClass tama_class);

/*---------------------------------------------------------------------------*/
/* TamaNext 饹                                                           */
/*---------------------------------------------------------------------------*/

TamaClass TamaNext_GetTamaClass(TamaNext tama_next);
double TamaNext_GetPower(TamaNext tama_next);
int TamaNext_GetNumber(TamaNext tama_next);

/*---------------------------------------------------------------------------*/
/* Tamas 饹                                                              */
/*---------------------------------------------------------------------------*/

TamaClass Tamas_GetTamaClass(Tamas tamas);
int Tamas_GetNumber(Tamas tamas);
double * Tamas_GetX(Tamas tamas);
double * Tamas_GetY(Tamas tamas);
double * Tamas_GetZ(Tamas tamas);
double * Tamas_GetVx(Tamas tamas);
double * Tamas_GetVy(Tamas tamas);
double * Tamas_GetVz(Tamas tamas);

/*===========================================================================*/
/* TamaClass ֥Ȥκ                                      */
/*===========================================================================*/

TamaClass TamaClass_Create(char * name,
			   int size,
			   double probability,
			   double air,
			   double gravity,
			   double transmission,
			   int after_image_length,
			   int fine,
			   ObjList gc_list_list,
			   ObjList next_list,
			   Disp disp);
TamaClass TamaClass_Destroy(TamaClass tama_class);

/*===========================================================================*/
/* TamaNext ֥Ȥκ                                       */
/*===========================================================================*/

TamaNext TamaNext_Create(TamaClass tama_class, double power, int n);
TamaNext TamaNext_Destroy(TamaNext next);

/*===========================================================================*/
/* ǡɤ߹                                                          */
/*===========================================================================*/

ObjList TamaClassList_CreateFromStream(Disp disp,
				       ColorGCDatabase database,
				       Stream stream,
				       char * background_color,
				       int fine);

/*===========================================================================*/
/* Tamas ֥Ȥ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* Tamas ֥Ȥ                                                  */
/*---------------------------------------------------------------------------*/

Tamas Tamas_Create(TamaClass tama_class, double power, int number, int n,
		   double * x, double * y, double * z,
		   double * vx, double * vy, double * vz,
		   int x_min, int y_min, int x_max, int y_max);

/*---------------------------------------------------------------------------*/
/* Tama ֥Ȥκ                                                   */
/*---------------------------------------------------------------------------*/

Tamas Tamas_Destroy(Tamas tamas);

/*---------------------------------------------------------------------------*/
/* Tamas ֥Ȥΰư                                                  */
/*---------------------------------------------------------------------------*/

AfterImages Tamas_Move(Tamas tamas,
		       int x_min, int y_min, int x_max, int y_max, int size);

#endif

/*****************************************************************************/
/* End of Program                                                            */
/*****************************************************************************/
