#include "XHanabi.h"
#include "arguments.h"

#ifndef VERSION
#define VERSION "XHanabi-unknown-version"
#endif

#ifndef XHANABI_DIRECTRY
#define XHANABI_DIRECTRY "/usr/X11R6/lib/X11/XHanabi"
#endif

#ifndef STUDYING_FLAG
#define STUDYING_FLAG 0
#endif

#ifndef CACHE_FLAG
#define CACHE_FLAG 1
#endif

#ifndef CACHE_SIZE
#define CACHE_SIZE 30
#endif

#ifndef HASH_NUMBER
#define HASH_NUMBER 1024
#endif

#ifndef TAMA_MAX_NUMBER
#define TAMA_MAX_NUMBER 100
#endif

#ifndef DEFAULT_FINE
#define DEFAULT_FINE 100
#endif

#ifndef DEFAULT_WAIT
#define DEFAULT_WAIT 0
#endif

#ifndef DEFAULT_GRADATION
#define DEFAULT_GRADATION 16
#endif

static char * display_name = ":0.0";
static char * background_color = "black";
static char * filename = "xhanabi.conf";
static int wait_time = DEFAULT_WAIT;
static int studying_flag = STUDYING_FLAG;
static int cache_flag = CACHE_FLAG;
static int cache_size = CACHE_SIZE;
static int hash_number = HASH_NUMBER;
static int tama_max_number = TAMA_MAX_NUMBER;
static int fine = DEFAULT_FINE;
static int gradation = DEFAULT_GRADATION;

void help()
{
  printf("%s\n\n", VERSION);
  printf("usage:\n");
  printf("xhanabi [-h, -help] [-display displayname]\n");
  printf("        [-bg, -background, -background-color backgroundcolor]\n");
  printf("        [-f, -file filename] [-wait microseconds] [-fine number]\n");
  exit (0);
}

Argument arguments[] = {
  {"-h",                ARGUMENTS_FUNCTION, (void *)(&help)},
  {"-help",             ARGUMENTS_FUNCTION, (void *)(&help)},
  {"-display",          ARGUMENTS_STRING,   (void *)(&display_name)},
  {"-bg",               ARGUMENTS_STRING,   (void *)(&background_color)},
  {"-background",       ARGUMENTS_STRING,   (void *)(&background_color)},
  {"-background-color", ARGUMENTS_STRING,   (void *)(&background_color)},
  {"-f",                ARGUMENTS_STRING,   (void *)(&filename)},
  {"-file",             ARGUMENTS_STRING,   (void *)(&filename)},
  {"-wait",             ARGUMENTS_INTEGER,  (void *)(&wait_time)},
  {"-fine",             ARGUMENTS_INTEGER,  (void *)(&fine)},
  {"-gradation",        ARGUMENTS_INTEGER,  (void *)(&gradation)},
  {"-tama-max-number",  ARGUMENTS_INTEGER,  (void *)(&tama_max_number)},

  /* ʲϥ塼˥ѤαץǤ */

  /* ؽǽѤˤϡʲͭˤޤ                      */
  /* ؽǽȥåʻѤǤޤʻѤƤ⤢ޤ̣Ϥޤ*/
  /* ؽǽѤȡ instance ꥹȤƬ˻ä          */
  /* 褦ˤʤޤϤǹ®                                  */
  /* ؽǽ̵ȡ򥽡ȤƳǼΤǡȤˡ        */
  /* ǼƤʤäФˡ˸Ǥڤ뤳ȤǤ褦*/
  /* ʤޤϤǹ®                                            */
  {"-studying",         ARGUMENTS_FLAG_ON,  (void *)(&studying_flag)},
  {"-no-studying",      ARGUMENTS_FLAG_OFF, (void *)(&studying_flag)},

  /* ʲͭˤȡåѤ褦ˤʤޤ */

  {"-cache",            ARGUMENTS_FLAG_ON,  (void *)(&cache_flag)},
  {"-no-cache",         ARGUMENTS_FLAG_OFF, (void *)(&cache_flag)},

  /* åΥꤷޤ */
  {"-cache-size",       ARGUMENTS_INTEGER,  (void *)(&cache_size)},

  /* ϥåΥꤷޤ */
  {"-hash-number",      ARGUMENTS_INTEGER,  (void *)(&hash_number)},

  {NULL,                ARGUMENTS_NONE,     NULL}
};

int main(int argc, char * argv[])
{
  XHanabi xhanabi;

  Arguments_Read(&argc, argv, arguments);
  if (fine <= 0) fine = 100;

  xhanabi = XHanabi_Create(display_name, background_color,
			   XHANABI_DIRECTRY, filename,
			   studying_flag, cache_flag, cache_size, hash_number,
			   fine, gradation);
  XHanabi_Start(xhanabi, tama_max_number, wait_time);
  XHanabi_Destroy(xhanabi);

  return (0);
}
